	.nolist
	#include "ion.inc"
	.list

#ifdef TI83P
	.org    progstart-2
	.db     $BB,6D
#else
	.org    progstart
#endif
	ret

	jr      nc,begin
	.db     "Minipaint TI 83+ for ION",0

;Group 1
KDown		.equ 254 
KLeft		.equ 253 
KRight		.equ 251 
KUp		.equ 247
kdownleft	.equ %11111100
kdownright	.equ %11111010
kupleft		.equ %11110101
kupright	.equ %11110011

;Group 2 
KEnter		.equ 254 
KPlus		.equ 253 
KMinus		.equ 251 
KMul		.equ 247 
KDiv		.equ 239 
KPower		.equ 223 
KClear		.equ 191 

;Group 3 
kMinus2		.equ 254 
kThree		.equ 253 
kSix		.equ 251 
kNine		.equ 247 
kRbracket	.equ 239 
kTan		.equ 223 
kVars		.equ 191 

;Group 4 
KPoint		.equ 254 
KTwo		.equ 253 
KFive		.equ 251
KEight		.equ 247
KLbracket	.equ 239
KCos		.equ 223
KPrgm		.equ 191
KStat		.equ 127 

;Group 5 
KZero		.equ 254
KOne		.equ 253
KFour		.equ 251
KSeven		.equ 247
KComma		.equ 239
KSin		.equ 223
KMatrx		.equ 191
KX		.equ 127 

;Group 6 
KSto		.equ 253
KLn		.equ 251
KLog		.equ 247
kX2		.equ 239
kX-1		.equ 223
kMath		.equ 191
kAlpha		.equ 127 

;Group 7 
KGraph		.equ 254
KTrace		.equ 253
KZoom		.equ 251
KWindow		.equ 247
KY		.equ 239
k2nd		.equ 223
kMode		.equ 191
kDel		.equ 127

;G5&6
ksave0		.equ 252
_CircCmd	.EQU 47D4h
_GrphCirc	.EQU 47D7h
curGY2		.EQU 8D1Ah
curGX2		.EQU 8D1Bh
;----------------------------------

begin:
	LD	(save_SP),SP
	set 	2,(IY+8)
	set	2,(IY+43)
	SET	3,(IY+20)
main:
	bcall(_clrlcdf)
	bcall(_cleargbuf)
	ld b,64			;the sprite is 16 high
	ld c,12			;it is 16 wide overall. Divide by 8 and we get 2
	ld a,0			;lets just display the sprite at (0,0)
	ld l,a
	ld ix,splash		;load the sprite into register ix
	call ionLargeSprite	;call the library
	bcall(_grbufcpy)	;copy the graph buffer to the screen--displaying the sprite
	call putcur2
mainloop:
	call reskeys
	call engroup7
	in a,(1)
	cp k2nd
	call z,conf
	call reskeys
	call engroup1
	in a,(1)
	cp kup
	call z,mup
	cp kdown
	call z,mdown
	cp kleft
	call z,mleft
	cp kright
	call z,mright
	cp kdownleft
	call z,mdownleft
	cp kdownright
	call z,mdownright
	cp kupleft
	call z,mupleft
	cp kupright
	call z,mupright
	jp mainloop
conf:
;if x>=a=>y
	ld a,(curposy)
	cp 2		;Lower y-bound (x)
	jr c,conf2
	cp 6		;Upper y-bound (y)
	jr c,chckquitx
	jr z,chckquitx
conf2:
	ld a,(curposy)
	cp 27		;Lower y-bound 
	jr c,conf3
	cp 31		;Upper y-bound
	jr c,chcknewgx
	jr z,chcknewgx
conf3:
	ld a,(curposy)
	cp 34		;Lower y-bound 
	jr c,conf4
	cp 38		;Upper y-bound
	jr c,chckcont2x
	jr z,chckcont2x
conf4:
	ld a,(curposy)
	cp 41		;Lower y-bound 
	jr c,conf5
	cp 45		;Upper y-bound
	jr c,chckinfox
	jr z,chckinfox
conf5:
	ld a,(curposy)
	cp 48		;Lower y-bound 
	jr c,conf6
	cp 52		;Upper y-bound
	jr c,chckcontx
	jr z,chckcontx
conf6:
	ret
chckquitx:
;if x>=a=>y
	ld a,(curposx)
	cp 89		;Lower x-bound (x)
	jr c,conf6
	cp 94		;Upper x-bound (y)
	jr nc,conf6
	jp quit
chckcontx:
;if x>=a=>y
	ld a,(curposx)
	cp 33		;Lower x-bound (x)
	jr c,conf6
	cp 58		;Upper x-bound (y)
	jr nc,conf6
	jp contact
chckcont2x:
;if x>=a=>y
	ld a,(curposx)
	cp 33		;Lower x-bound (x)
	jr c,conf6
	cp 61		;Upper x-bound (y)
	jr nc,conf6
	jp contpict
chcknewgx:
;if x>=a=>y
	ld a,(curposx)
	cp 33		;Lower x-bound (x)
	jr c,conf6
	cp 60		;Upper x-bound (y)
	jr nc,conf6
	jp newpict
chckinfox:
;if x>=a=>y
	ld a,(curposx)
	cp 33		;Lower x-bound (x)
	jr c,conf6
	cp 53		;Upper x-bound (y)
	jr nc,conf6
	jr info
contact:
	bcall(_clrlcdf)
	bcall(_cleargbuf)
	ld hl,txtcont
	ld bc,(24*256)+24
	call puttxt
	ld bc,(30*256)+13
	call puttxt
	bcall(_getkey)
	jp main
info:
	bcall(_clrlcdf)
	bcall(_cleargbuf)
	ld b,11
	ld c,63
	ld d,11
	ld e,58
	ld h,1
	bcall(_iline)
	ld hl,txtinfo
	set 3,(iy+5)
	ld bc,(0*256)+12
	call puttxt
	res 3,(iy+5)
	ld bc,(7*256)+21
	call puttxt
	ld bc,(12+6*256)+0
	call puttxt
	ld bc,(12+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6+6+6+6*256)+0
	call puttxt
	ld b,11
	ld c,57
	ld d,86
	ld e,57
	ld h,1
	bcall(_iline)
	bcall(_getkey)
	bcall(_clrlcdf)
	ld hl,txtinfo2
	ld bc,(0*256)+0
	call puttxt
	ld bc,(6*256)+0
	call puttxt
	ld bc,(6+6*256)+0
	call puttxt
	ld bc,(6+6+6*256)+0
	call puttxt
	ld bc,(6+6+6+6*256)+0
	call puttxt
	ld bc,(6+6+6+6+6*256)+0
	call puttxt
	bcall(_getkey)
	jp main
puttxt:
	ld (pencol),bc
	bcall(_vputs)
	ret
mup:
	call putcur2
	call mup_pressed
	call putcur2
	ld a,1
	ret
mdown:
	call putcur2
	call mdown_pressed
	call putcur2
	ld a,1
	ret
mleft:
	call putcur2
	call mleft_pressed
	call putcur2
	ld a,1
	ret
mright:
	call putcur2
	call mright_pressed
	call putcur2
	ld a,1
	ret
mupleft:
	call putcur2
	call mup_pressed
	call mleft_pressed
	call putcur2
	ld a,1
	ret
mupright:
	call putcur2
	call mup_pressed
	call mright_pressed
	call putcur2
	ld a,1
	ret
mdownleft:
	call putcur2
	call mdown_pressed
	call mleft_pressed
	call putcur2
	ld a,1
	ret
mdownright:
	call putcur2
	call mdown_pressed
	call mright_pressed
	call putcur2
	ld a,1
	ret
mDown_Pressed:
	ld a, (curposy)
	cp 61
	jp z, mGetKeyLoop2
	inc a
mGetKeyLoop2:
	ld (curposy), a
	ret
mUp_Pressed:
	ld a, (curposy)	
	cp 0
	jp z, mGetKeyLoop3
	dec a
mGetKeyLoop3:
	ld (curposy), a
	ret
mLeft_Pressed:
	ld a, (curposx)
	or a
	jp z, mGetKeyLoop4
	dec a
mGetKeyLoop4:
	ld (curposx), a
	ret
mRight_Pressed:
	ld a, (curposx)	
	cp 93
	jp z, mGetKeyLoop5
	inc a
mGetKeyLoop5:
	ld (curposx), a
	ret
;--------------------------
;      Drawing loop!
;--------------------------
newpict:
	bcall(_clrlcdfull)
	bcall(_cleargbuf)
	jr enitloop
contpict:
	call tempload
enitloop:
	ld a,0
	ld (pointzize),a
	ld a,30
	ld (curposy),a
	inc a
	inc a
	inc a
	ld (pointy),a
	ld a,46
	ld (curposx),a
	ld (pointx),a
	call putcur
drawloop:
	call reskeys
	call engroup1
	in a,(1)
	cp kup
	call z,up
	cp kdown
	call z,down
	cp kleft
	call z,left
	cp kright
	call z,right
	cp kdownleft
	call z,downleft
	cp kdownright
	call z,downright
	cp kupleft
	call z,upleft
	cp kupright
	call z,upright
	call reskeys
	call engroup2
	in a,(1)
	cp kclear
	jp z,quit
	cp kenter
	call z,showmenu
	cp kplus
	call z,pointup
	cp kminus
	call z,pointdown
	call reskeys
	call engroup5
	in a,(1)
	cp kmatrx
	call z,drawcircle
	call reskeys
	call engroup6
	in a,(1)
	cp kalpha
	call z,erase
	call reskeys
	call engroup7
	in a,(1)
	cp k2nd
	call z,addpoint
	cp kdel
	call z,clearall
	cp ky
	jp z,retmain
	cp kwindow
	call z,save
	cp kzoom
	call z,load
	cp ktrace
	call z,help
	cp kgraph
	call z,undo
	jp drawloop
inchl1:
	inc hl
	ret
drawcircle:
	ld a,(pointx)
	ld (curgx2),a
	ld a,(pointy)
	ld (curgy2),a
	call tempsave
	ld hl,txtcircle
	ld bc,(30*256)+10
	call puttxt
	ld bc,(36*256)+30
	call puttxt
	bcall(_getkey)
	call tempload
	call putcur
circleloop:
	call reskeys
	call engroup1
	in a,(1)
	cp kup
	call z,up
	cp kdown
	call z,down
	cp kleft
	call z,left
	cp kright
	call z,right
	cp kdownleft
	call z,downleft
	cp kdownright
	call z,downright
	cp kupleft
	call z,upleft
	cp kupright
	call z,upright
	call reskeys
	call engroup2
	in a,(1)
	cp kclear
	jp z,exitcircle
	call reskeys
	call engroup7
	in a,(1)
	cp k2nd
	jr z,contcircle
	jp circleloop
contcircle:
	ld a,(pointx)
	ld (curgx),a
	ld a,(pointy)
	ld (curgy),a
	call putcur
	bcall(_grphcirc)
	call putcur
	jp drawloop
exitcircle:
	xor a
	ld de,5
	ld hl,0
uff:
	inc a
	cp 255
	call z,inchl1
	bcall(_cphlde)
	jp nz,uff
	jp drawloop
showmenu:
	call putcur
	call tempsave
	set 2,(iy+43)
	ld c,0
	ld e,0
	ld l,6
	push bc
	push de
smloop:
	pop de
	pop bc
	push bc
	push de
	ld b,0
	ld d,95
	ld h,0
	bcall(_iline)
	pop de
	pop bc
	inc c
	inc e
	push bc
	push de
	dec l
	ld a,l
	jr nz,smloop
	pop bc
	pop de
	ld b,0
	ld d,95
	ld h,1
	bcall(_iline)
	ld hl,smtxt
	ld bc,(58*256)+5
	call puttxt
	bcall(_getkey)
	bcall(_clrlcdf)
	call tempload
	call putcur
	ret
help:
	call tempsave
	bcall(_clrlcdf)
	bcall(_cleargbuf)
	ld b,11
	ld c,63
	ld d,11
	ld e,58
	ld h,1
	bcall(_iline)
	ld hl,txtinfo
	set 3,(iy+5)
	ld bc,(0*256)+12
	call puttxt
	res 3,(iy+5)
	ld bc,(7*256)+21
	call puttxt
	ld bc,(12+6*256)+0
	call puttxt
	ld bc,(12+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6+6+6*256)+0
	call puttxt
	ld bc,(12+6+6+6+6+6+6*256)+0
	call puttxt
	ld b,11
	ld c,57
	ld d,86
	ld e,57
	ld h,1
	bcall(_iline)
	bcall(_getkey)
	bcall(_clrlcdf)
	ld hl,txtinfo2
	ld bc,(0*256)+0
	call puttxt
	ld bc,(6*256)+0
	call puttxt
	ld bc,(6+6*256)+0
	call puttxt
	ld bc,(6+6+6*256)+0
	call puttxt
	ld bc,(6+6+6+6*256)+0
	call puttxt
	ld bc,(6+6+6+6+6*256)+0
	call puttxt
	bcall(_getkey)
	bcall(_clrlcdf)
	bcall(_cleargbuf)
	call tempload
	xor a
	ret
backup:
	call putcur
	ld hl,plotsscreen
	ld de,undobackup
	ld bc,768
	ldir
	call putcur
	ret
undo:
	call putcur
	call tempsave
	bcall(_clrlcdf)
	ld hl,undobackup
	ld de,plotsscreen
	ld bc,768
	ldir
	ld hl,screenbackup
	ld de,undobackup
	ld bc,768
	ldir
	call putcur
	xor a
	ld de,3
	ld hl,0
undoloop:
	inc a
	cp 255
	call z,inchl1
	bcall(_cphlde)
	jp nz,undoloop
	ret
retmain:
	call putcur
	call tempsave
	jp main
pointzero:
	xor a
	ld (pointtype),a
	ld a,10
	ret
pointone:
	ld a,1
	ld (pointtype),a
	ld a,10
	ret
pointup:
	xor a
	ld de,5
	ld hl,0
upchngloop:
	inc a
	cp 255
	call z,inchl1
	bcall(_cphlde)
	jp nz,upchngloop
	ld a, (pointzize)
	cp 2
	jp z, pointup2
	inc a
pointup2:
	ld (pointzize), a
	ld a,1
	ret
pointdown:
	xor a
	ld de,5
	ld hl,0
downchngloop:
	inc a
	cp 255
	call z,inchl1
	bcall(_cphlde)
	jp nz,downchngloop
	ld a, (pointzize)
	cp 0
	jp z, pointdown2
	dec a
pointdown2:
	ld (pointzize), a
	ld a,1
	ret
addpoint:
	call backup
addpoint2:
	ld a,1
	ld (pointtype),a
	ld a,(pointzize)
	cp 0
	call z,putsmall
	ld a,(pointzize)
	cp 1
	call z,putmedium
	ld a,(pointzize)
	cp 2
	call z,putlarge
	call reskeys
	call engroup1
	in a,(1)
	cp kup
	call z,up
	cp kdown
	call z,down
	cp kleft
	call z,left
	cp kright
	call z,right
	cp kdownleft
	call z,downleft
	cp kdownright
	call z,downright
	cp kupleft
	call z,upleft
	cp kupright
	call z,upright
	call reskeys
	call engroup7
	in a,(1)
	cp k2nd
	jp z,addpoint2
	ret
erase:
	call backup
erase2:
	ld a,0
	ld (pointtype),a
	ld a,(pointzize)
	cp 0
	call z,putsmall
	ld a,(pointzize)
	cp 1
	call z,putmedium
	ld a,(pointzize)
	cp 2
	call z,putlarge
	call reskeys
	call engroup1
	in a,(1)
	cp kup
	call z,up
	cp kdown
	call z,down
	cp kleft
	call z,left
	cp kright
	call z,right
	cp kdownleft
	call z,downleft
	cp kdownright
	call z,downright
	cp kupleft
	call z,upleft
	cp kupright
	call z,upright
	call reskeys
	call engroup6
	in a,(1)
	cp kalpha
	jp z,erase2
	ret
putsmall:
	ld a,(pointy)
	ld c,a
	ld a,(pointx)
	ld b,a
	call sputpoint
	call putcur
	ret
putmedium:
;Col 1
	ld a,(pointx)
	ld b,a
	push bc
	push bc
	ld a,(pointy)
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint
;Col 2
	ld a,(pointy)
	ld c,a
	ld a,(pointx)
	inc a
	ld b,a
	push bc
	push bc
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint
;Col 3
	ld a,(pointy)
	ld c,a
	ld a,(pointx)
	dec a
	ld b,a
	push bc
	push bc
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint
	call putcur
	ret
putlarge:
;Col 1
	call putcur
	ld a,(pointx)
	ld b,a
	push bc
	push bc
	push bc
	push bc
	ld a,(pointy)
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	dec a
	ld c,a
	call sputpoint
;Col 2
	ld a,(pointy)
	ld c,a
	ld a,(pointx)
	inc a
	ld b,a
	push bc
	push bc
	push bc
	push bc
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	dec a
	ld c,a
	call sputpoint
;Col 3
	ld a,(pointy)
	ld c,a
	ld a,(pointx)
	inc a
	inc a
	ld b,a
	push bc
	push bc
	push bc
	push bc
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	dec a
	ld c,a
	call sputpoint
;Col 4
	ld a,(pointy)
	ld c,a
	ld a,(pointx)
	dec a
	ld b,a
	push bc
	push bc
	push bc
	push bc
	call sputpoint
	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	dec a
	ld c,a
	call sputpoint
;Col 5
	ld a,(pointy)
	ld c,a
	ld a,(pointx)
	dec a
	dec a
	ld b,a
	push bc
	push bc
	push bc
	push bc
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	inc a
	inc a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	ld c,a
	call sputpoint

	pop bc
	ld a,(pointy)
	dec a
	dec a
	ld c,a
	call sputpoint
	call putcur
	ret
clearall:
	call backup
clrloop:
	bcall(_clrlcdfull)
	bcall(_cleargbuf)
	call putcur
	call reskeys
	call engroup7
	in a,(1)
	cp kdel
	jr z,clrloop
	ret
save:
	call putcur
;-------------------------------------------------
;This is modified code! The original is in AsmGuru
;I take no credit for the original code! Ian Graf 
;wrote it and James Matthew publiced it in AsmGuru
;The changes has ';---' around them
;-------------------------------------------------
     bcall(_zeroop1)    ; load var name

;----------------------
     ld hl,pic0name     
;----------------------

     ld de,op1         
     ld bc,3          
     ldir              

;----------------------
     bcall(_chksysvar)  ; look it up
;----------------------

     jp nc,load_data   ; skip to loaddata if exists.

;----------------------
	bcall(4333h)	;Create pic
;----------------------
load_data:
     inc de            ; skip 1st length byte
     inc de            ; skip 2nd length byte

;----------------------
     ld hl,plotsscreen     ; screen data
;----------------------

     ld bc,756         ; pic size
     ldir              ; copy data
;---------------------------------------------------
;Screen -> PIC ends here
;---------------------------------------------------
	xor a
	ld de,5
	ld hl,0
captureloop:
	inc a
	cp 255
	call z,inchl1
	bcall(_cphlde)
	jp nz,captureloop
	call putcur
	ret

load:
	call putcur
	bcall(_clrlcdf)
     bcall(_zeroop1)    ; load var name

;----------------------
     ld hl,pic0name     
;----------------------

     ld de,op1         
     ld bc,3          
     ldir              

;----------------------
     bcall(_chksysvar)  ; look it up
;----------------------

     jp nc,load_data2   ; skip to loaddata if exists.

;----------------------
	bcall(4333h)	;Create pic
;----------------------
load_data2:
     inc de            ; skip 1st length byte
     inc de            ; skip 2nd length byte
	ex de,hl
     ld de,plotsscreen     ; screen data
     ld bc,756         ; pic size
     ldir              ; copy data

	xor a
	ld de,3
	ld hl,0
loadloop:
	inc a
	cp 255
	call z,inchl1
	bcall(_cphlde)
	jp nz,loadloop
	call putcur
	ret
up:
	call putcur
	call up_pressed
	call putcur
	ld a,1
	ret
down:
	call putcur
	call down_pressed
	call putcur
	ld a,1
	ret
left:
	call putcur
	call left_pressed
	call putcur
	ld a,1
	ret
right:
	call putcur
	call right_pressed
	call putcur
	ld a,1
	ret
upleft:
	call putcur
	call up_pressed
	call left_pressed
	call putcur
	ld a,1
	ret
upright:
	call putcur
	call up_pressed
	call right_pressed
	call putcur
	ld a,1
	ret
downleft:
	call putcur
	call down_pressed
	call left_pressed
	call putcur
	ld a,1
	ret
downright:
	call putcur
	call down_pressed
	call right_pressed
	call putcur
	ld a,1
	ret
Down_Pressed:
	ld a, (curposy)
	cp 63
	jp z, GetKeyLoop2
	inc a
GetKeyLoop2:
	ld (curposy), a
	ld a, (pointy)
	cp 0
	jp z, GetKeyLoop2p
	dec a
GetKeyLoop2p:
	ld (pointy), a
	ret
Up_Pressed:
	ld a, (curposy)	
	cp 0
	jp z, GetKeyLoop3
	dec a
GetKeyLoop3:
	ld (curposy), a
	ld a, (pointy)	
	cp 63
	jp z, GetKeyLoop3p
	inc a
GetKeyLoop3p:
	ld (pointy), a
	ret
Left_Pressed:
	ld a, (curposx)
	or a
	jp z, GetKeyLoop4
	dec a
GetKeyLoop4:
	ld (curposx), a
	ld (pointx),a
	ret
Right_Pressed:
	ld a, (curposx)	
	cp 95
	jp z, GetKeyLoop5
	inc a
GetKeyLoop5:
	ld (curposx), a
	ld (pointx),a
	ret
putcur:
	ld a,(curposy)
	ld l,a
	ld ix,spcur
	ld a,(curposx)
	ld b,5
	call ionPutSprite
	call ionFastCopy
	ret


;--------------------------
reskeys:
	ld a,0ffh
	out (1),a
	ret
engroup1:
	ld a,0feh
	out (1),a
	ret
engroup2:
	ld a,0fdh
	out (1),a
	ret
engroup3:
	ld a,0fbh
	out (1),a
	ret
engroup4:
	ld a,0f7h
	out (1),a
	ret
engroup5:
	ld a,0efh
	out (1),a
	ret
engroup6:
	ld a,0dfh
	out (1),a
	ret
engroup7:
	ld a,0bfh
	out (1),a
	ret
engroup56:
	ld a,0cfh
	out (1),a
	ret
putcur2:
	ld a,(curposy)
	ld l,a
	ld ix,spcur2
	ld a,(curposx)
	ld b,3
	call ionPutSprite
	call ionFastCopy
	ret
spcur2:
	.db %11100000
	.db %11000000
	.db %10100000
quit:
	call putcur
	call tempsave
	call reskeys
	LD	SP,(save_SP)
	RET
tempsave:
	ld hl,plotsscreen
	ld de,screenbackup
	ld bc,768
	ldir
	ret
tempload:
	ld hl,screenbackup
	ld de,plotsscreen
	ld bc,768
	ldir
	ret
curposx:
	.db 20
curposy:
	.db 20
save_sp:
	.db 0,0
sputpoint:
	ld a,(pointtype)
	ld d,a
	bcall(_ipoint)
	ret
spcur:
	.db %10000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

pointx:
	.db 0
pointy:
	.db 0
pointtype:
	.db 1
pointzize:
	.db 0
temp:
	.db 0
txtinfo:
	.db "Minipaint TI83+ for ION",0
	.db "by: Jonas Thesl",$a9,"f",0
	.db $cf,$05,$1e,$1f," : Move cursor",0
	.db "2nd: Draw",0
	.db "Alpha: Erase",0
	.db "+/-: Inc/dec penzize",0
	.db "Enter: Popup-menu",0
	.db "Y=: Return to main menu",0
txtinfo2:
	.db "Window: Save to PIC0",0
	.db "Zoom: Load from PIC0",0
	.db "Trace: This menu",0
	.db "Graph: Undo",0
	.db "Del: Clear screen",0
	.db "Clear: Exit",0
txtcont:
	.db "e-mail me at:",0
	.db "theslof@hotmail.com",0
smtxt:
	.db "Menu  Save  Load  Help  Undo",0
txtcircle:
	.db "Press 2nd on outer radius",0
	.db "Clear to exit!",0
Pic0Name:
	.DB	7,60h,09h,0
splash:
 .db $7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FE,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$DD,$7D,$FF,$7D,$C5,$13,$FD,$FF
 .db $BF,$FF,$FF,$83,$C9,$CF,$39,$CC,$ED,$5D,$BB,$B5,$B6,$7F,$FF,$AB
 .db $D5,$55,$55,$55,$ED,$1B,$19,$53,$AA,$BF,$FF,$93,$DD,$55,$35,$55
 .db $ED,$5D,$BB,$57,$AA,$BF,$FF,$AB,$DD,$55,$79,$56,$ED,$13,$FB,$B7
 .db $B6,$BF,$FF,$83,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$80,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
 .db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$30,$01,$80,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$4C,$01,$80,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$43,$01,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$98,$C1
 .db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$A6,$31,$80,$00,$00,$00
 .db $00,$00,$00,$00,$00,$01,$21,$89,$80,$00,$00,$00,$00,$00,$00,$00
 .db $00,$01,$4C,$55,$80,$00,$00,$00,$00,$00,$00,$00,$00,$02,$50,$55
 .db $80,$00,$00,$00,$00,$00,$00,$00,$00,$02,$80,$A9,$80,$00,$00,$00
 .db $00,$00,$00,$00,$00,$04,$80,$A9,$80,$00,$00,$00,$00,$00,$00,$00
 .db $00,$04,$61,$51,$80,$00,$00,$00,$00,$00,$00,$00,$00,$08,$19,$51
 .db $80,$00,$00,$00,$00,$00,$00,$00,$00,$0B,$06,$A1,$80,$00,$00,$00
 .db $00,$00,$00,$00,$00,$10,$C0,$A1,$80,$00,$00,$00,$00,$00,$00,$00
 .db $00,$16,$31,$41,$80,$00,$00,$00,$60,$00,$08,$20,$01,$E1,$8D,$41
 .db $80,$00,$00,$00,$52,$44,$C1,$B0,$06,$2C,$62,$81,$80,$00,$00,$00
 .db $55,$54,$AA,$20,$08,$43,$1A,$C1,$80,$00,$00,$00,$56,$54,$CA,$20
 .db $0E,$58,$C5,$C1,$80,$00,$00,$00,$53,$28,$89,$90,$09,$E6,$3F,$41
 .db $80,$00,$00,$00,$00,$00,$00,$00,$08,$1F,$E2,$C1,$80,$00,$00,$00
 .db $00,$00,$00,$00,$18,$00,$01,$41,$80,$00,$00,$00,$30,$04,$80,$00
 .db $28,$03,$02,$C1,$80,$00,$00,$00,$42,$66,$30,$10,$28,$03,$01,$41
 .db $80,$00,$00,$00,$45,$54,$AA,$A8,$48,$04,$02,$C1,$80,$00,$00,$00
 .db $45,$54,$AA,$B0,$48,$04,$01,$41,$80,$00,$00,$00,$32,$52,$A9,$98
 .db $48,$08,$02,$C1,$80,$00,$00,$00,$00,$00,$00,$00,$28,$10,$01,$41
 .db $80,$00,$00,$00,$00,$00,$00,$00,$18,$60,$02,$C1,$80,$00,$00,$00
 .db $70,$20,$00,$00,$0F,$80,$01,$41,$80,$00,$00,$00,$26,$44,$00,$00
 .db $08,$00,$02,$C1,$80,$00,$00,$00,$25,$6A,$00,$00,$08,$00,$01,$41
 .db $80,$00,$00,$00,$25,$4A,$00,$00,$08,$00,$02,$C1,$80,$00,$00,$00
 .db $75,$44,$A8,$00,$08,$00,$01,$41,$80,$00,$00,$00,$00,$00,$00,$00
 .db $08,$00,$02,$C1,$80,$00,$00,$00,$00,$00,$00,$00,$08,$00,$01,$41
 .db $80,$00,$00,$00,$30,$04,$00,$80,$08,$00,$02,$C1,$80,$00,$00,$00
 .db $42,$66,$66,$C0,$08,$00,$01,$41,$80,$00,$00,$00,$45,$54,$A8,$80
 .db $06,$00,$03,$81,$80,$00,$00,$00,$45,$54,$A8,$80,$01,$E0,$1E,$01
 .db $80,$00,$00,$00,$32,$52,$66,$40,$00,$1F,$E0,$01,$80,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$01,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01
 .db $80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00
 .db $00,$00,$00,$00,$0A,$20,$DD,$1D,$80,$00,$00,$00,$00,$00,$00,$00
 .db $0A,$51,$11,$11,$80,$00,$00,$00,$00,$00,$00,$00,$0A,$51,$D9,$99
 .db $80,$00,$00,$00,$00,$00,$00,$00,$04,$51,$45,$45,$80,$00,$00,$00
 .db $00,$00,$00,$00,$04,$25,$D9,$99,$80,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$01,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
undobackup:
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
screenbackup:
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
 .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

;------------------------------------------------------------------



.end
END